import uk.ac.ed.ph.dia.*;
import uk.ac.ed.ph.jfftw.*;


public class RealFT {

    public static void main(String args[]) {

	if (args.length == 0) {
            System.err.println("Usage: java ImageTest filename");
            System.exit(1);
        }
        String file = args[0];
        RealImage image = RealImage.fromPGMFile(file);
        System.out.println(image.toString());

	FFTWReal fftw = new FFTWReal();

	double ft[] = fftw.twoDimensionalForward(image.getWidth(),
						 image.getHeight(),
						 image.getDataBuffer());

	int w = image.getWidth()/2 + 1;
	int h = image.getHeight();

	RealImage ftlog = new RealImage(w,h);

	for(int j = 0; j < h; j++) {
	    for(int i = 0; i < w; i++) {
		int s = (j*w + i)*2;
		int t = s + 1;
		ftlog.setPixel(i,j,Math.log(ft[s]*ft[s] +
					    ft[t]+ft[t] + 1.0));
	    }
	}

	DisplayImage display = new DisplayImage("Log of FT");
	display.addImage(ftlog);
	display.setVisible(true);
	display.centre();


	double rec[] = fftw.twoDimensionalBackward(image.getWidth(),
						  image.getHeight(),
						  ft);

	for(int j = 0; j < image.getHeight(); j++) {
	    for(int i = 0; i < image.getWidth(); i++) {
		image.setPixel(i,j,rec[j*image.getWidth() + i]);
	    }
	}

	DisplayImage displayR = new DisplayImage("Reconstruction");
	displayR.addImage(image);
	displayR.setVisible(true);
	displayR.centre();


    }
}
