import uk.ac.ed.ph.jfftw.*;

/**           Method ot otest the two-dimensional comlex fft
 */

public class SplitTwoDimensional {
    public static void main(String args[]) {

	int w = 400;                // Non square array
	int h = 300;

	double[] rp = new double[w*h];  // Make real part.
	for(int i = 0; i < w*h; i++) {
	    rp[i] = Math.random();
	}

	//                         Make interleaved array with zero imaginary 
	double[] dataInterleave = ArrayUtil.interleave(rp,null);
	
	//                         Make split array
	double[][] dataSplit = ArrayUtil.split(rp,null);

	//         Make Complex FFT
	FFTWComplex fft = new FFTWComplex();
	//         FFT both array formats
	dataInterleave = fft.twoDimensional(w,h,dataInterleave,1,true);
	dataSplit = fft.twoDimensional(w,h,dataSplit,-1,true);

	//         Form difference bwteeen modulus square (should be zero).
	double diff = 0.0;
	for(int i = 0; i < w*h; i++) {
	    double a = ArrayUtil.getComplex(dataInterleave,i).modulusSq();
	    double b = ArrayUtil.getComplex(dataSplit,i).modulusSq();
	    diff += Math.abs(a - b);
	}
	System.out.println("Difference is " + diff);
    

    }
}
	