import uk.ac.ed.ph.jfftw.*;

/**     Simple test program for two dimensional FFts
 */


public class TwoDimensions extends Object {
    public static void main(String args[]) {

	int width = 200;
	int height = 300;

	double[] data = new double[2*width*height];

	//        Fill real parts with randoms.
	for(int j = 0; j < height; j++) {
	    for(int i = 0; i < width; i++) {
		data[2*(j*width + i)] = Math.random();
	    }
	}

	FFTWComplex fft = new FFTWComplex();


	//    Take out of place forward fft
	double[] ft = fft.twoDimensional(width,height,data,1,false);
       
	//    Take in place backwords fft  
	fft.twoDimensional(width,height,ft,-1,true);
	
	// Normalise...
	double size = width*height;
	for(int i = 0; i < ft.length; i++) {
	    ft[i] /= size;
	}

	//   Check difference

	double diff = 0;
	for(int i = 0; i < width*height; i++) {
	    double d = data[2*i] - ft[2*i];     // real part
	    diff += d*d;
	}

	System.out.println("Difference is : " + diff);


	

    }
}